#pragma once
#include "fs/devices/DeviceRegistry.h"

class FullDevice : public Device
{
  public:
    // Initializer for DeviceRegistry.
    static Result<void> create();

    Result<usize> read(u8* buf, usize, usize length) const override
    {
        __builtin_memset(buf, 0, length);

        return length;
    }

    Result<usize> write(const u8*, usize, usize) override
    {
        return err(ENOSPC);
    }

    bool blocking() const override
    {
        return false;
    }

    virtual ~FullDevice() = default;
};
